DECLARE SUB Eingabe (ef%, et%, ez%)
DECLARE SUB ColNrm (lc%)
DECLARE SUB ColDom (lc%)
DECLARE SUB ColAnz (lc%)
DECLARE SUB ColRot (lc%)
DECLARE SUB ColGelb (lc%)
DECLARE SUB ColGruen (lc%)
DECLARE SUB ColEdit (lc%)
DECLARE SUB ColErr (lc%)
DECLARE SUB ColLetzt ()
DECLARE SUB OutWerte (z%)
DECLARE SUB Rahmen (VonPos%, BisPos%)
DECLARE SUB Text (cp%, t$)
DECLARE SUB ClrMenu ()
DECLARE SUB Taste (ix$)
DECLARE SUB SetErr (t$)
DECLARE SUB WeiterTast (cp%, t$)
DECLARE SUB SetCol (lc%, lcv%, lch%)
DECLARE SUB SetCPos (cp%)
DECLARE SUB InpLokNr ()

' ===============================================================
' Globale Arrays und Variable
' ===============================================================
CONST AnzLok% = 8
CONST AnzCmd% = 8
DIM SHARED ReglA%, ReglN%, ReglCP%
DIM SHARED WeicheA%, WeicheN%, WeicheCP%
DIM SHARED ZeitA$, ZeitN$, ZeitCP%

DIM SHARED WertA%(AnzLok%, AnzCmd%)
DIM SHARED WertN%(AnzLok%, AnzCmd%)
DIM SHARED WertCP%(AnzLok%, AnzCmd%)

DIM SHARED AbfzA$(AnzLok%)
DIM SHARED AbfzN$(AnzLok%)
DIM SHARED AbfzCP%(AnzLok%)

DIM SHARED CmdTxt$(11), FeWeMin%(11), FeWeMax%(11), FeWeMin%, FeWeMax%
DIM SHARED Tast$, Tast%
DIM SHARED CmdStr$, CmdOut$
CmdStr$ = ""
CmdOut$ = ""

DIM SHARED EingR$, EingR%, EingX$, EingW$, EingY$
EingR$ = "1"
EingX$ = "15"
EingW$ = "  1"
EingY$ = "00:00"

DIM SHARED Sio%, Versuche%, Verbind%, Sio$, Lett$, Ziff$, Ziff%, Semi%
DIM SHARED Datei$

DIM SHARED i$, in$, zm%, en%, fm%, CPos%, LColV%, LColH%, ii%
DIM SHARED LVonZl%, LBisZl%

CONST KHD$ = "KH Domnick    MOdell-Bahn-Steuerung (MOBS)   Vers. 2.5"
CONST Weiter$ = "Weiter mit beliebiger Taste ..... "
CONST Fertig$ = "Fertig !  Beliebige Taste drcken "
CONST Abbruch$ = "Abgebrochen !  Taste drcken .... "
CONST Zahl$ = "1234567890"
CONST Zeichen$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"

DIM SHARED ZahlSpc$, ZahlHex$, ZahlZeich$
ZahlSpc$ = Zahl$ + " "
ZahlHex$ = Zahl$ + "ABCDEF"
ZahlZeich$ = Zahl$ + Zeichen$

DIM SHARED Trenn$, ComNr$, ComNr
Trenn$ = "," + CHR$(13)
ComNr$ = "1": ComNr% = 1

' ###############################################################
' FUNKTIONEN
' ###############################################################

' ---------------------------------------------------------------
' FUNKTION Umwandlung von Wert$ in Wert& (nach Fmt%)
' ---------------------------------------------------------------
DEF FNconvSW& (Wert$, fmt%)
STATIC ZLen%, NKom%, VKom%, z%, Wert&
   ZLen% = fmt% \ 10
   NKom% = fmt% MOD 10
   VKom% = ZLen% - NKom%

   IF RIGHT$(Wert$, 1) = "-" THEN
      Wert& = -1
      GOTO WertEnd2
   END IF

   IF RIGHT$(Wert$, 1) = "*" THEN
      Wert& = VAL(STRING$(ZLen%, "9"))
      GOTO WertEnd2
   END IF

   IF NKom% > 0 THEN
      Wert$ = LTRIM$(RTRIM$(LEFT$(Wert$, VKom%))) + RIGHT$(Wert$, NKom%)
      FOR z% = 1 TO LEN(Wert$)
	 IF MID$(Wert$, z%, 1) = " " THEN
	    MID$(Wert$, z%, 1) = "0"
	 END IF
      NEXT z%
   END IF

   Wert& = VAL(Wert$)
WertEnd2:
   FNconvSW& = Wert&
END DEF

' ---------------------------------------------------------------
' FUNKTION Linke und rechte Leerzeichen entfernen
' ---------------------------------------------------------------
DEF FNtrim$ (i$)
   FNtrim$ = LTRIM$(RTRIM$(i$))
END DEF

' ---------------------------------------------------------------
' FUNKTION Wert in String umwandeln und linkes Leerzeichen entfernen
' ---------------------------------------------------------------
DEF FNlval$ (i&)
   FNlval$ = LTRIM$(STR$(i&))
END DEF

' ###############################################################
' PROGRAMM
' ###############################################################
PrgAnfang:
   CALL ColNrm(1)
   CLS
   CALL Rahmen(304, 2178)
   CALL Text(215, KHD$)
   CALL Text(510, "Initialisierung ............")

   GOSUB InitVar
   GOSUB OpenSio

   ON COM(ComNr%) GOSUB SioInp
   COM(ComNr%) ON

   ON TIMER(1) GOSUB SioOut
   TIMER ON
   PRINT #1, "K0"       ' Kommando-Quittung aus

' ===============================================================
' Haupt-Men
' ===============================================================
   CALL Text(506, "    Regler ............     1     2     3     4     5     6     7     8")
   CALL Text(606, "<A> " + CmdTxt$(1))
   CALL Text(706, "<G> " + CmdTxt$(2))
   CALL Text(806, "<M> " + CmdTxt$(3))
   CALL Text(906, "    " + CmdTxt$(4))
   CALL Text(1006, "    " + CmdTxt$(5))
   CALL Text(1106, "<F> " + CmdTxt$(6))
   CALL Text(1206, "<H> " + CmdTxt$(7))
   CALL Text(1306, "<U> " + CmdTxt$(8))
   CALL Text(1406, "<Y> " + CmdTxt$(9))
   CALL Text(1506, "<Z> " + CmdTxt$(10))
   CALL Text(1606, "<W> " + CmdTxt$(11))
   CALL Text(1706, "    <ESC> Programm beenden / Eingabe abbrechen")
   CALL Text(1758, "Auswahl:")
  
   CALL OutWerte(1)

MenuH:
   CALL ClrMenu
   CALL SetCPos(1767)
   CALL Taste("AGMFHUYZW")
   IF zm% THEN
      CALL Text(1923, "Programm wirklich beenden ? : ")
      CALL Taste("JjNn")
      IF UCASE$(i$) = "J" THEN GOTO PrgEnde
      GOTO MenuH
   END IF
  
   IF Sio% = 0 OR Verbind% > 2 THEN GOTO MenuH

   Tast$ = UCASE$(i$)
   Tast% = INSTR("AGMelFHUYZW", Tast$)
   IF Tast% = 0 THEN GOTO MenuH
		 'A        G        M        e    l    F        H        U        Y        Z        W
   ON Tast% GOSUB InpWert, InpWert, InpWert, Nix, Nix, InpWert, InpWert, InpWert, InpAbfz, InpZeit, InpWeiche

   GOTO MenuH

Nix:
RETURN

' ===============================================================
' LokNr eingeben
' ===============================================================
InpLokNr:
   CALL ColDom(1)
   CALL Text(1914, "  Regler Nr.: ")
   FeWeMin% = 1
   FeWeMax% = AnzLok%
   in$ = EingR$
   CALL Eingabe(10, 0, 0): IF zm% THEN RETURN
   EingR$ = in$
   CmdStr$ = "R" + in$
RETURN

' ===============================================================
' Wert eingeben
' ===============================================================
InpWert:
   GOSUB InpLokNr
   CALL ColDom(1)
   CALL Text(1934, CmdTxt$(Tast%))
   FeWeMin% = FeWeMin%(Tast%) MOD 100
   fmt% = FeWeMin%(Tast%) \ 100
   FeWeMax% = FeWeMax%(Tast%)
   in$ = EingX$
   CALL Eingabe(fmt%, 0, 0): IF zm% THEN RETURN
   EingX$ = in$
   CmdOut$ = CmdStr$ + ", " + Tast$ + in$
RETURN

' ===============================================================
' Abfahrzeit eingeben
' ===============================================================
InpAbfz:
   GOSUB InpLokNr
   EingR% = VAL(EingR$)
   CALL ColDom(1)
   CALL Text(1934, CmdTxt$(9))
   FeWeMin% = 0
   fmt% = 22
   FeWeMax% = 2359
   in$ = AbfzA$(EingR%)
   CALL Eingabe(fmt%, 0, 1): IF zm% THEN RETURN
   EingY$ = in$
   CmdOut$ = CmdStr$ + ", " + "Y" + in$
RETURN

' ===============================================================
' Zeit eingeben
' ===============================================================
InpZeit:
   EingR% = VAL(EingR$)
   CALL ColDom(1)
   CALL Text(1934, CmdTxt$(10))
   FeWeMin% = 0
   fmt% = 22
   FeWeMax% = 2359
   in$ = EingY$
   CALL Eingabe(fmt%, 0, 1): IF zm% THEN RETURN
   EingY$ = in$
   CmdOut$ = "Z" + in$ + ":00"
RETURN

' ===============================================================
' Weichen-Nummer eingeben
' ===============================================================
InpWeiche:
   CALL ColDom(1)
   CALL Text(1934, CmdTxt$(Tast%))
   FeWeMin% = FeWeMin%(Tast%) MOD 100
   fmt% = FeWeMin%(Tast%) \ 100
   FeWeMax% = FeWeMax%(Tast%)
   in$ = EingW$
   CALL Eingabe(fmt%, 0, 0): IF zm% THEN RETURN
   EingW$ = in$
   CmdOut$ = "W" + in$
RETURN

' ===============================================================
' Serielle Schnittstelle ffnen
' ===============================================================
OpenSio:
  'Datei$ = "COM" + ComNr$ + ":9600,N,8,1,BIN,CD10,CS10,DS10,,OP0,RB1024"
   Datei$ = "COM" + ComNr$ + ":9600,N,8,1,BIN,,,,,,RB1024"
   ON ERROR GOTO OpenSio5
   OPEN Datei$ FOR RANDOM AS #1       ' ComX ffnen
   ON ERROR GOTO 0
   IF fm% THEN CALL SetErr("")
   Sio% = 1
RETURN

OpenSio5:
   RESUME OpenSio6
OpenSio6:
   ON ERROR GOTO 0
   CLOSE
   CALL SetErr("Keine Verbindung zum System !")
   fm% = 0
   Sio% = 0
RETURN

' ===============================================================
' Daten an SIO ausgeben
' ===============================================================
SioOut:
   IF Sio% = 0 THEN
      Versuche% = Versuche% + 1
      IF Versuche% > 10 THEN
	 Versuche% = 0
	 GOSUB OpenSio
      END IF
   END IF

   IF Sio% = 1 THEN
      Verbind% = Verbind% + 1
      IF Verbind% > 3 THEN
	 Verbind% = 3
	 CALL SetErr("Keine Verbindung zum System !")
	 fm% = 0
      ELSE
	 IF fm% = 0 THEN
	    CALL SetErr("")
	 END IF
	 IF CmdOut$ <> "" THEN
	    PRINT #1, CmdOut$
	    CmdOut$ = ""
	 END IF
	 PRINT #1, "S"
	 CALL OutWerte(0)
      END IF
   END IF
RETURN

' ===============================================================
' Daten von SIO einlesen
' ===============================================================
SioInp:
   Verbind% = 0
   WHILE NOT EOF(1)
      Sio$ = INPUT$(1, #1)
      IF Semi% THEN
	 IF INSTR(CHR$(13), Sio$) THEN
	    Semi% = 0
	 END IF
      ELSE
	 IF INSTR(";", Sio$) THEN
	    Lett$ = ""
	    Ziff$ = ""
	    Semi% = 1
	 ELSEIF INSTR("RAGMELFHUYZW", Sio$) THEN
	    Lett$ = Sio$
	    Ziff$ = ""
	 ELSEIF INSTR(Zahl$ + ".:", Sio$) THEN
	    Ziff$ = Ziff$ + Sio$
	 ELSEIF INSTR(Trenn$, Sio$) THEN
	     IF INSTR("RAGMELFHUW", Lett$) > 0 THEN
		Ziff% = VAL(Ziff$)
	     END IF
	     SELECT CASE Lett$
	      CASE "R"                      ' Regler-Nummer
		ReglN% = Ziff%
	      CASE "A"                      ' Adresse Lok
		WertN%(ReglN%, 1) = Ziff%
	      CASE "G"                      ' Geschwindigkeits-Aenderung
		WertN%(ReglN%, 2) = Ziff%
	      CASE "M"                      ' Max Fahrstufe
		WertN%(ReglN%, 3) = Ziff%
	      CASE "E"                      ' Einstell-Regler
		WertN%(ReglN%, 4) = Ziff%
	      CASE "L"                      ' Lok-Fahrstufe (Aktuell)
		WertN%(ReglN%, 5) = Ziff%
	      CASE "F"                      ' Feste Fahrstufe
		WertN%(ReglN%, 6) = Ziff%
	      CASE "H"                      ' Halt-Zeit
		WertN%(ReglN%, 7) = Ziff%
	      CASE "U"                      ' Umschaltung
		WertN%(ReglN%, 8) = Ziff%
	      CASE "Y"                      ' Abfahr-Zeit
		AbfzN$(ReglN%) = Ziff$
	      CASE "Z"                      ' Zeit
		ZeitN$ = Ziff$
	      CASE "W"                      ' Weiche
		WeicheN% = Ziff%
	     END SELECT
	     Lett$ = ""
	     Ziff$ = ""
	 END IF
      END IF
   WEND
RETURN

' ===============================================================
' Variablen initialisieren
' ===============================================================
InitVar:
Spalte% = 33 - 6
FOR l% = 1 TO AnzLok%
   Zeile% = 6 - 1
   Spalte% = Spalte% + 6
   FOR w% = 1 TO AnzCmd%
      Zeile% = Zeile% + 1
      WertCP%(l%, w%) = (Zeile% * 100) + Spalte%
   NEXT w%
   FOR w% = 1 TO AnzCmd%
      WertA%(l%, w%) = -1
      WertN%(l%, w%) = 0
   NEXT w%
NEXT l%

Spalte% = 30 - 6
FOR l% = 1 TO AnzLok%
   Spalte% = Spalte% + 6
   AbfzCP%(l%) = 1400 + Spalte%
   AbfzA$(l%) = "     "
   AbfzN$(l%) = "  :  "
NEXT l%

ReglCP% = 1560
ZeitCP% = 1530
WeicheCP% = 1632

ReglA% = -1: ReglN% = 0
ZeitA$ = "": ZeitN$ = "  :  :  "
WeicheA% = -1: WeicheN% = 0

CmdTxt$(1) = "Adresse Lok   0..80  "
CmdTxt$(2) = "Geschw.-nd.  1..99  "
CmdTxt$(3) = "Max Fahrstufe 2..15  "
CmdTxt$(4) = "Einstell-Reg. 0..15  "
CmdTxt$(5) = "Lok-Fahrstufe 0..15  "
CmdTxt$(6) = "Feste Fahrst. 0..15  "
CmdTxt$(7) = "Halt [Sek.]   0..99  "
CmdTxt$(8) = "Umschaltung   0..99  "
CmdTxt$(9) = "Abfahrzeit    hh:mm  "
CmdTxt$(10) = "Zeit          hh:mm  "
CmdTxt$(11) = "Weiche       1..640  "

FeWeMin%(1) = 2000: FeWeMax%(1) = 80
FeWeMin%(2) = 2001: FeWeMax%(2) = 99
FeWeMin%(3) = 2002: FeWeMax%(3) = 15
FeWeMin%(4) = 2000: FeWeMax%(4) = 15
FeWeMin%(5) = 2000: FeWeMax%(5) = 15
FeWeMin%(6) = 2000: FeWeMax%(6) = 15
FeWeMin%(7) = 2000: FeWeMax%(7) = 99
FeWeMin%(8) = 2000: FeWeMax%(8) = 99

FeWeMin%(11) = 3001: FeWeMax%(11) = 640

RETURN

' ###############################################################
' FEHLER-BEHANDLUNG
' ###############################################################
' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
PrgAbort:
   CALL Text(200, "Programm wird abgebrochen !")
   CALL WeiterTast(200, Weiter$)

PrgEnde:
   PRINT #1, "K1"       ' Kommando-Quittung ein
   COLOR 7, 0
   CLS
   END

' ---------------------------------------------------------------
' Untere Bildzeilen lschen
' ---------------------------------------------------------------
SUB ClrMenu STATIC
   CALL ColNrm(1)
   CALL Text(1767, "_")
REM   CALL Text(1806, SPACE$(69))
   CALL Text(1906, SPACE$(69))
   CALL Text(2006, SPACE$(69))
END SUB

' ###############################################################
' SUB-ROUTINEN
' ###############################################################
' ---------------------------------------------------------------
' Vorder- (0...15) und Hintergrund- (0...7) Farben
' 0  schwarz             8  grau
' 1  blau                9  hellblau
' 2  grn               10  hellgrn
' 3  trkis             11  helltrkis
' 4  rot                12  hellrot
' 5  violett            13  hellviolett
' 6  braun              14  gelb
' 7  wei               15  hellwei
' ---------------------------------------------------------------
SUB ColAnz (lc%) STATIC
   lcv% = 15
   lch% = 0
   CALL SetCol(lc%, lcv%, lch%)
END SUB

SUB ColDom (lc%) STATIC
   lcv% = 14
   lch% = 1
   CALL SetCol(lc%, lcv%, lch%)
END SUB

SUB ColEdit (lc%) STATIC
   lcv% = 15
   lch% = 7
   CALL SetCol(lc%, lcv%, lch%)
END SUB

SUB ColErr (lc%) STATIC
   lcv% = 15 + 16
   lch% = 4
   CALL SetCol(lc%, lcv%, lch%)
END SUB

SUB ColRot (lc%) STATIC
   lcv% = 15
   lch% = 4
   CALL SetCol(lc%, lcv%, lch%)
END SUB

SUB ColGelb (lc%) STATIC
   lcv% = 15
   lch% = 3
   CALL SetCol(lc%, lcv%, lch%)
END SUB

SUB ColGruen (lc%) STATIC
   lcv% = 15
   lch% = 2
   CALL SetCol(lc%, lcv%, lch%)
END SUB

SUB ColLetzt STATIC
   COLOR LColV%, LColH%
END SUB

SUB ColNrm (lc%) STATIC
   lcv% = 15
   lch% = 1
   CALL SetCol(lc%, lcv%, lch%)
END SUB

' ===============================================================
' Eingabe-Routine
' ===============================================================
SUB Eingabe (ef%, et%, ez%) STATIC

   ' en%   Funktions-Nummer 0 = keine / 1...8
   ' et%   Funktions-Tasten 0 = nicht erlaubt / 1 = erlaubt / 5..9 = Zeit
   ' ef%   Eingabe-Format:
   '       0 = String (alle Zeichen erlaubt)
   '       1 = Laufwerk
   '       2 = Pfad
   '       3 = Dateiname
   '       4 = Laufwerk, Pfad, Dateiname
   '       5 = Ja/Nein
   '       6 =
   '       7 =
   '       8 =
   '       9 =
   '       10 .... 99 = Zahlen-Format

   IF in$ = "" THEN in$ = " "
   ix$ = in$
   em% = LEN(in$)                  ' Eingaben-Maximum
   IF ef% > 9 THEN
      ed% = ef% MOD 10             ' Dezimalpunkt-Pos
      IF ed% > 0 THEN ed% = em% - ed%
   ELSE
      ed% = 0
   END IF
   ep% = 1                         ' Position = 1
   ea% = 0                         ' Eingaben-Anzahl = 0
   en% = 0                         ' Funktions-Nr.
   zm% = 0                         ' Zum Men = 0

   y% = CSRLIN
   x% = POS(0)
   CALL ColEdit(1)
   GOTO EingAnz1

EingAnz:
   ea% = 1

EingAnz1:
   LOCATE y%, x%, 0
   PRINT ix$;

EingNext:
   'CALL ColEdit(0)
   IF ins% THEN
       LOCATE y%, x% + ep% - 1, 1, 1, 7
   ELSE
       LOCATE y%, x% + ep% - 1, 1, 6, 7
   END IF
   i$ = ""
   DO
      i$ = INKEY$
   LOOP WHILE i$ = ""
   'IF i$ = "" THEN GOTO EingNext

   IF fm% THEN CALL SetErr("")

   IF LEN(i$) = 1 THEN GOTO Eing1Byte

' Auf Steuertasten prfen
   SELECT CASE ASC(MID$(i$, 2))
    CASE 72                                        'Pfeil auf
      en% = 1
    CASE 80                                        'Pfeil ab
      en% = 2
    CASE 71                                        'Home
      ep% = 1
      GOTO EingNext
    CASE 79                                        'End
      ep% = em%
      WHILE ep% > 1 AND MID$(ix$, ep%, 1) = " "
	 ep% = ep% - 1
      WEND
      IF ep% < em% THEN ep% = ep% + 1
      GOTO EingAnz
    CASE 75, 115                                   '<-- / ^<--
      IF ep% > 1 THEN GOTO EingCPZur
    CASE 77, 116                                   '--> / ^-->
      IF ep% < em% THEN GOTO EingCPVor
    CASE 82                                        'INS
      IF ins% = 0 THEN ins% = 1 ELSE ins% = 0
      GOTO EingNext
    CASE 83                                        'DEL
      GOTO EingDEL

    CASE 73                                        'PgUp
      en% = 3
    CASE 81                                        'PgDn
      en% = 4
    CASE 132                                       '^PgUp
      en% = 5
    CASE 118                                       '^PgDn
      en% = 6
    CASE 119                                       '^Home
      en% = 7
    CASE 117                                       '^End
      en% = 8
   END SELECT

   IF en% > 0 THEN GOTO EingStTast
   GOTO EingFalsch

Eing1Byte:
   SELECT CASE ASC(i$)
    CASE 27                                        ' ESC
      zm% = 2
      GOTO EingAbbr
    CASE 13                                        'RETURN
      GOTO EingEnd
    CASE 19                                        '^S
      IF ep% > 1 THEN GOTO EingCPZur
    CASE 4                                         '^D
      IF ep% < em% THEN GOTO EingCPVor
    CASE 21                                        '^U
      ix$ = in$
      ep% = 1
      GOTO EingAnz
    CASE 8, 127                                    'BS
      IF ep% > 1 THEN GOTO EingBS
    CASE 22                                        '^V
      IF ins% = 0 THEN ins% = 1 ELSE ins% = 0
      GOTO EingNext
    CASE 25                                        '^Y
      GOTO EingLoe

    CASE 5                                         '^E
      en% = 1
    CASE 24                                        '^X
      en% = 2
    CASE IS < 32
      GOTO EingFalsch
   END SELECT

   IF en% > 0 THEN GOTO EingStTast

' Auf Eingabesperren testen
   SELECT CASE ef%
    CASE 0                                         ' String
      IF INSTR(ZahlZeich$ + " ,.-;:_&/()=?!+", UCASE$(i$)) = 0 THEN GOTO EingFalsch
    CASE 1                                         ' Laufwerk
      i$ = UCASE$(i$)
      IF INSTR(Zeichen$ + " ", i$) = 0 THEN GOTO EingFalsch
    CASE 2                                         ' Pfad
      i$ = UCASE$(i$)
      IF INSTR(ZahlZeich$ + "\._", i$) = 0 THEN GOTO EingFalsch
    CASE 3                                         ' Dateiname
      i$ = UCASE$(i$)
      IF INSTR(ZahlZeich$ + "_", i$) = 0 THEN GOTO EingFalsch
    CASE 4                                         ' Laufwerk, Pfad, Dateiname
      i$ = UCASE$(i$)
      IF INSTR(ZahlZeich$ + ":\._", i$) = 0 THEN GOTO EingFalsch
    CASE 5                                         ' Ja/Nein
      i$ = UCASE$(i$)
      IF INSTR("JN", i$) = 0 THEN GOTO EingFalsch
    CASE IS > 9                                    'Ziffern
      IF ed% > 0 AND INSTR(".:", i$) > 0 THEN
	 ep% = ed% + 1
	 GOTO EingNext
      END IF
      IF i$ = "/" THEN
	 ix$ = in$
	 ep% = 1
	 GOTO EingAnz
      END IF
      IF INSTR(Zahl$, i$) = 0 THEN GOTO EingFalsch
   END SELECT

' Bei 1. Eingabe erst Eingabe-Feld lschen
   IF ea% = 0 THEN
      IF ef% > 9 AND ed% > 0 THEN
	 ix$ = SPACE$(ed% - 1) + ":" + STRING$(em% - ed%, "0")
      ELSE
	 ix$ = SPACE$(em%)
      END IF
   END IF

' Eingabe im Eingabe-Feld ablegen
   IF ins% THEN
      IF ed% > 0 THEN
	 IF ep% > ed% THEN
	    ix$ = LEFT$(ix$, ep% - 1) + i$ + MID$(ix$, ep%, em% - ep%)
	 ELSE
	    ix$ = MID$(ix$, 2, ep% - 1) + i$ + RIGHT$(ix$, em% - ep%)
	 END IF
      ELSE
	 ix$ = LEFT$(ix$, ep% - 1) + i$ + MID$(ix$, ep%, em% - ep%)
      END IF
   ELSE
      MID$(ix$, ep%, 1) = i$
   END IF

   IF em% = 1 THEN GOTO EingEnd
   IF ep% = em% THEN GOTO EingAnz

EingCPVor:
   ep% = ep% + 1
   IF ed% > 0 AND ep% = ed% THEN ep% = ep% + 1
   IF ep% > em% THEN
      ep% = em%
      IF ed% > 0 AND ep% = ed% THEN ep% = ep% - 1
   END IF
   GOTO EingAnz

EingCPZur:
   ep% = ep% - 1
   IF ed% > 0 AND ep% = ed% THEN ep% = ep% - 1
   IF ep% < 1 THEN
      ep% = 1
      IF ed% > 0 AND ep% = ed% THEN ep% = ep% + 1
   END IF
   GOTO EingAnz

EingStTast:
   IF et% > 0 AND et% < 5 THEN GOTO EingEnd
   en% = 0

EingFalsch:
   IF VAL(KDat$(4)) THEN BEEP
   GOTO EingNext

EingLoe:
   IF ed% > 0 THEN
      IF ep% > ed% THEN
	 ix$ = LEFT$(ix$, ep% - 1) + STRING$(em% - ep% + 1, "0")
      ELSE
	 ix$ = LEFT$(ix$, ep% - 1) + SPACE$(ed% - ep%) + RIGHT$(ix$, em% - ed% + 1)
      END IF
   ELSE
      ix$ = LEFT$(ix$, ep% - 1) + SPACE$(em% - ep% + 1)
   END IF
   GOTO EingAnz

EingDEL:
   IF ed% > 0 THEN
      IF ep% > ed% THEN
	 ix$ = LEFT$(ix$, ep% - 1) + MID$(ix$, ep% + 1, em% - ep%) + "0"
      ELSE
	 ix$ = " " + LEFT$(ix$, ep% - 1) + MID$(ix$, ep% + 1, em% - ep%)
      END IF
   ELSE
      ix$ = LEFT$(ix$, ep% - 1) + RIGHT$(ix$, em% - ep%) + " "
   END IF
   GOTO EingAnz

EingBS:
   IF ep% - 1 = ed% THEN GOTO EingFalsch
   IF ed% > 0 THEN
      IF ep% > ed% THEN
	 ix$ = LEFT$(ix$, ep% - 2) + MID$(ix$, ep%, em% - ep% + 1) + "0"
      ELSE
	 ix$ = LEFT$(ix$, ep% - 2) + MID$(ix$, ep%, ed% - ep%) + " " + RIGHT$(ix$, em% - ed% + 1)
      END IF
   ELSE
      ix$ = LEFT$(ix$, ep% - 2) + MID$(ix$, ep%, em% - ep% + 1) + " "
   END IF
   GOTO EingCPZur

EingEnd:
   in$ = ix$
   IF ez% = 1 THEN
      it$ = LEFT$(in$, 2) + RIGHT$(in$, 2)
      it% = VAL(it$)
      IF it% > FeWeMax% THEN
	 CALL SetErr("Eingabe-Wert ist zu gro")
	 GOTO EingAnz
      END IF	   
   END IF

   IF ef% > 9 THEN
      IF VAL(in$) < FeWeMin% THEN
	 CALL SetErr("Eingabe-Wert ist zu klein")
	 GOTO EingAnz
      ELSEIF VAL(in$) > FeWeMax% THEN
	 CALL SetErr("Eingabe-Wert ist zu gro")
	 GOTO EingAnz
      END IF
   END IF

EingAbbr:
   CALL ColAnz(0)
   LOCATE y%, x%, 0, 6, 7: PRINT in$;
   CALL ColLetzt
   LOCATE y%, x%
END SUB

' ---------------------------------------------------------------
' Textfenster setzen
' 0               letzte Werte setzen
' ---------------------------------------------------------------
SUB Fenster (VonZl%, BisZl%) STATIC
   IF VonZl% > 0 THEN LVonZl% = VonZl%
   IF BisZl% > 0 THEN LBisZl% = BisZl%
   VIEW PRINT LVonZl% TO LBisZl%
END SUB

' ---------------------------------------------------------------
' Alle Werte anzeigen
' ---------------------------------------------------------------
SUB OutWerte (z%) STATIC
   y% = CSRLIN: x% = POS(0)
   CALL ColAnz(0)
   FOR l% = 1 TO AnzLok%
      FOR w% = 1 TO AnzCmd%
	 IF (WertA%(l%, w%) <> WertN%(l%, w%)) OR z% = 1 THEN
	    WertA%(l%, w%) = WertN%(l%, w%)
	    CALL SetCPos(WertCP%(l%, w%))
	    IF w% = 1 AND WertA%(l%, w%) = 0 THEN
		CALL ColGelb(0)	' gelb
	    ELSEIF w% = 5 THEN
		IF WertA%(l%, w%) = 0 THEN
		   CALL ColRot(0)	' rot
		ELSE
		   CALL ColGruen(0)	' grn
		END IF
	    END IF
	    PRINT USING "##"; WertA%(l%, w%);
	 END IF
	 CALL ColAnz(0)
      NEXT w%
   NEXT l%

  FOR l% = 1 TO AnzLok%
     IF (AbfzA$(l%) <> AbfzN$(l%)) OR z% = 1 THEN
	 AbfzA$(l%) = AbfzN$(l%)
	 IF AbfzA$(l%) <> "00:00" THEN
	    CALL ColGruen(0)	' gruen
	 END IF
	 CALL SetCPos(AbfzCP%(l%))
	 PRINT AbfzA$(l%);
     END IF
     CALL ColAnz(0)
  NEXT l%

   IF (ZeitA$ <> ZeitN$) OR z% = 1 THEN
	ZeitA$ = ZeitN$
	CALL SetCPos(ZeitCP%)
	PRINT ZeitA$;
   END IF

   IF (WeicheA% <> WeicheN%) OR z% = 1 THEN
      WeicheA% = WeicheN%
      CALL SetCPos(WeicheCP%)
      PRINT USING "###"; WeicheA%;
   END IF

   LOCATE y%, x%
   CALL ColLetzt
END SUB

' ---------------------------------------------------------------
' Rahmen auf Bildschirm bilden
' ---------------------------------------------------------------
SUB Rahmen (VonPos%, BisPos%) STATIC
   VonZeile% = VonPos% \ 100
   VonSpalte% = VonPos% MOD 100
   BisZeile% = BisPos% \ 100
   BisSpalte% = BisPos% MOD 100
   LOCATE VonZeile%, VonSpalte%, 0
   PRINT ""; STRING$(BisSpalte% - VonSpalte% - 1, ""); "";
   FOR z% = VonZeile% + 1 TO BisZeile% - 1
       LOCATE z%, VonSpalte%: PRINT "";
       LOCATE z%, BisSpalte%: PRINT "";
   NEXT
   LOCATE BisZeile%, VonSpalte%, 1
   PRINT ""; STRING$(BisSpalte% - VonSpalte% - 1, ""); "";
END SUB

' ---------------------------------------------------------------
' Farbe setzen
' ---------------------------------------------------------------
SUB SetCol (lc%, lcv%, lch%) STATIC
   IF lc% THEN
      LColV% = lcv%
      LColH% = lch%
   END IF
   COLOR lcv%, lch%
END SUB

' ---------------------------------------------------------------
' Curser positionieren
' 100 ... 2400    Curser an letzter Spalte 1 ... 24 Zeilen tiefer
' ---------------------------------------------------------------
SUB SetCPos (cp%) STATIC
   cpz% = cp% \ 100
   cps% = cp% MOD 100
   IF cps% = 0 THEN
      cpz% = (CPos% \ 100) + cpz%
      cps% = CPos% MOD 100
   END IF
   IF cpz% < 1 OR cpz% > 25 THEN cpz% = 25
   IF cps% < 1 OR cps% > 80 THEN cps% = 1
   CPos% = (cpz% * 100) + cps%
   LOCATE cpz%, cps%
END SUB

' ---------------------------------------------------------------
' In Zeile 25 Fehlermeldung zentriert ausgeben
' ---------------------------------------------------------------
SUB SetErr (t$) STATIC
   IF t$ = "" THEN
      CALL ColDom(0)
      fm% = 0
   ELSE
      CALL ColErr(0)
      fm% = 1
   END IF
   y% = CSRLIN: x% = POS(0)
   CALL Text(25, SPACE$(78))
   IF t$ <> "" THEN
      CALL Text(25, t$)
      IF VAL(KDat$(4)) THEN BEEP
   END IF
   CALL ColLetzt
   LOCATE y%, x%
END SUB

' ---------------------------------------------------------------
' Auf Taste warten
' Vorgabe von ix$ und <ESC> auswerten
' ---------------------------------------------------------------
SUB Taste (ix$) STATIC
   zm% = 0
   DO: LOOP WHILE INKEY$ <> ""
   i$ = ""
Taste1:
   LOCATE , , 1
   DO
      i$ = UCASE$(INKEY$)
   LOOP WHILE i$ = ""
   IF i$ = "" THEN GOTO Taste1
  'IF fm% THEN CALL SetErr("")
   IF ASC(i$) = 27 THEN zm% = 2: EXIT SUB
   IF ix$ = "" THEN EXIT SUB
   IF INSTR(ix$, i$) = 0 THEN GOTO Taste1
   PRINT i$;
END SUB

' ---------------------------------------------------------------
' Curser positionieren und Text ausgeben
' 0               Text an letzte Position
' 1 ... 25        Text in Zeile 1 ... 25 zentriert
' 100 ... 2400    Text 1 ... 24 Zeilen tiefer
' ---------------------------------------------------------------
SUB Text (cp%, t$) STATIC
   IF cp% > 0 AND cp% < 26 THEN
      cp% = 1 + (cp% * 100) + (80 - LEN(t$)) \ 2
   END IF
   CALL SetCPos(cp%)
   PRINT t$;
END SUB

' ---------------------------------------------------------------
' Curser positionieren, "Weiter ..." ausgeben und auf Taste warten
' 0               Text an letzte Position
' 1 ... 25        Text in Zeile 1 ... 25 zentriert
' 100 ... 2400    Text 1 ... 24 Zeilen tiefer
' ---------------------------------------------------------------
SUB WeiterTast (cp%, t$) STATIC
   IF cp% > 0 AND cp% < 26 THEN
      cp% = (cp% * 100) + (81 - LEN(t$)) \ 2
   END IF
   CALL SetCPos(cp%)
   PRINT t$;
   CALL Taste("")
END SUB

